knnselect <-
function(X, Y, maxk="default", OddQ=FALSE, plot.it=TRUE, ...){
#
  if (nrow(X)!=length(Y)) stop("nrow(X) != length(Y)")
  n <- length(Y)
  if (n < 2)
    stop("need at minimum 2 observations!")
  YCLASSES <- unique(Y)
  K <- length(YCLASSES)
  if (K < 2)
    stop("there must be at least 2 classes")
  if (K > n/2)
    stop(paste("must have fewer than n/2 classes, n=",n))
#Shahid, this is just temporary, please generalize.
  if (K!=2)
    stop("current version is for K=2! Please generalize!!")
  if (!all(YCLASSES %in% c(-1,1)))
    stop(" classes must also be -1 or 1. Please generalize!!")
#
#GENERALIZATION:
#as long as the vector Y is comprised of distinct things, all character
#variables or factors or numbers like -1 and 1. Then we should redefine
#and work with y defined as 1, 2, ..., K, where K is the number of classes.
#I think this is the code needed - but I have commented it out:
  y <- Y
#  for (i in 1:K) {
#    ind <- Y == YCLASSES[i]
#    y[ind] <- i
#  }
  if (is.character(maxk))
    kmax<-floor(n/2)
  else
    kmax<-min(maxk, n-1)
  ks<-seq(1, kmax, ifelse(OddQ,2,1))
  LogL <- numeric(length(ks))
  names(LogL)<-ks
  for (i in 1:length(ks)) {
    z=knnz(k=ks[i], X=X, Y=y, ...)
#y must be 0 or 1 for binomial
    LogL[i] <- suppressWarnings(-0.5*(glm.fit(x=z, y=(Y+1)/2,family=binomial(link="logit")))$aic - 1)
    }
  kopt <- ks[which.max(LogL)]
  if (plot.it) {
    plot(ks,LogL, xlab="k", ylab="pseudo-log-likelihood", type="b", col="black", lwd=2)
    abline(v=kopt, lty=2, col="green")
    title(main=bquote(hat(k)==.(kopt)))
  }
  kopt                                    
}

