knnz <-
function(k, X, Y, ...){
# Computes the kNN covariate in training data
# 
# k     : value of nearest neighbor defined by Holmes et. al(2002)
# X     : input, training data
# y     : numeric vector of class labels, -1 and +1
#
   if (nrow(X)!=length(Y)) stop("nrow(X) != length(Y)")
   K <- unique(Y)
   if (length(K) != 2)
     stop("must have only 2 classes")
   y <- Y
   if (!all(y%in%c(-1,1))) 
      stop("y must be vector of 1 or -1's")
    ans<- knn.cv(train = X, cl = as.factor(y), k = k, prob = TRUE, use.all = FALSE, ...)
    pr<- attr(ans, "prob") #proportion of votes for winning class
    yfit<-as.numeric(as.character(ans)) #predicted classes as numeric -1 or +1
    NumberOfVotesForWinner <- pr*k
    NumberOfVotesForLoser <- k - NumberOfVotesForWinner
    ConsensusProportion <- (NumberOfVotesForWinner - NumberOfVotesForLoser)/k
    yfit*ConsensusProportion
}

