\name{knnselect}
\alias{knnselect}

\title{
Select optimal k for kNN
}
\description{
Implements the method of Holmes and Adams (2003) for selecting the best k 
in kNN classfication algorithm.
}
\usage{
knnselect(X, Y, maxk = "default", OddQ = FALSE, plot.it = TRUE, ...)
}
\arguments{

  \item{X}{
training data inputs or covariates
}
  \item{Y}{
training data output. Must correspond to K classes.
}
  \item{maxk}{
Maximum number of nearest neighbours.
}
  \item{OddQ}{
If TRUE, only odd values of the number of neighbours, k, are considered.
}
  \item{plot.it}{
If TRUE, plot is generated.
}
  \item{\dots}{
Optional arguments which are passed through to knn.cv.
}
}

\details{
More details later.
}

\value{
k, the pseudo MLE estimate for k
}

\references{
Holmes, C. C. and Adams, Niall M. (2003).  
Likelihood inference in nearest-neighbour classification models.
Biometrika 90, 99 - 112.
}

\author{
Shahidul M. Islam and A. I. McLeod
}

\note{
More later.
}



\seealso{
\code{\link{knnz}}
}

\examples{

data(trainSyn)
s.tr<-trainSyn
Xtr<-s.tr[,1:2]
ytr<-ifelse(s.tr[,3]==0,-1,1)
knnselect(X=Xtr,Y=ytr, maxk=100)
knnselect(X=Xtr,Y=ytr, maxk=100, OddQ=TRUE)

}

\keyword{ classif }
