\name{trainSyn}
\alias{trainSyn}
\docType{data}
\title{
Ripley's synthetic mixture data. Train sample.
}
\description{
This synthetic example (Ripley, 1994, 1996)  with K=2 was generated using equal mixtures of 
two normal distributions with a common covariance matrix for each class.  
The training data and test data sample sizes are 250 and 1000 
respectively and both contain equal numbers from each of the two classes. 
}

\usage{data(trainSyn)}
\format{
  A data frame with 250 observations on the following 3 variables.
  \describe{
    \item{\code{x1}}{input, a numeric vector}
    \item{\code{x2}}{input, a numeric vector}
    \item{\code{y}}{output, 0 or 1}
  }
}
\source{
http://www.stats.ox.ac.uk/pub/PRNN/
}

\references{
Ripley, B.D. (1994).  Neural Networks and Related Methods for Classification. 
Journal of the Royal Statistical Society. Series B (Methodological), Vol. 56, No. 3 (1994), pp. 409-456.

Ripley, B.D. (1996).  Pattern Recognition and Neural Networks.  Cambridge University Press.
}

\examples{
data(trainSyn)
str(trainSyn)
}
\keyword{datasets}


